Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 39)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! z0 removed from arguments in calls of diffusion_u/v/w
 !
 ! Former revisions:
@@ -130,8 +130,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend, u_m,   &
-                               usws_m, v_m, w_m, z0 )
+                               usws_m, v_m, w_m )
           ELSE
              CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, usws, &
-                               v, w, z0 )
+                               v, w )
           ENDIF
           CALL coriolis( i, j, 1 )
@@ -198,8 +198,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend, u_m, &
-                               v_m, vsws_m, w_m, z0 )
+                               v_m, vsws_m, w_m )
           ELSE
              CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v,  &
-                               vsws, w, z0 )
+                               vsws, w )
           ENDIF
           CALL coriolis( i, j, 2 )
@@ -265,8 +265,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x, km_damp_y,  &
-                               tend, u_m, v_m, w_m, z0 )
+                               tend, u_m, v_m, w_m )
           ELSE
              CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y,    &
-                               tend, u, v, w, z0 )
+                               tend, u, v, w )
           ENDIF
           CALL coriolis( i, j, 3 )
@@ -668,8 +668,8 @@
              THEN
                 CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend,  &
-                                  u_m, usws_m, v_m, w_m, z0 )
+                                  u_m, usws_m, v_m, w_m )
              ELSE
                 CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, &
-                                  usws, v, w, z0 )
+                                  usws, v, w )
              ENDIF
              CALL coriolis( i, j, 1 )
@@ -718,8 +718,8 @@
              THEN
                 CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend,     &
-                                  u_m, v_m, vsws_m, w_m, z0 )
+                                  u_m, v_m, vsws_m, w_m )
              ELSE
                 CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v, &
-                                  vsws, w, z0 )
+                                  vsws, w )
              ENDIF
              CALL coriolis( i, j, 2 )
@@ -767,8 +767,8 @@
              THEN
                 CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x,          &
-                                  km_damp_y, tend, u_m, v_m, w_m, z0 )
+                                  km_damp_y, tend, u_m, v_m, w_m )
              ELSE
                 CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y, &
-                                  tend, u, v, w, z0 )
+                                  tend, u, v, w )
              ENDIF
              CALL coriolis( i, j, 3 )
@@ -1041,7 +1041,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_u( ddzu, ddzw, km_m, km_damp_y, tend, u_m, usws_m, v_m, &
-                         w_m, z0 )
+                         w_m )
     ELSE
-       CALL diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w, z0 )
+       CALL diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w )
     ENDIF
     CALL coriolis( 1 )
@@ -1113,7 +1113,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_v( ddzu, ddzw, km_m, km_damp_x, tend, u_m, v_m, vsws_m, &
-                         w_m, z0 )
+                         w_m )
     ELSE
-       CALL diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w, z0 )
+       CALL diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w )
     ENDIF
     CALL coriolis( 2 )
@@ -1184,8 +1184,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_w( ddzu, ddzw, km_m, km_damp_x, km_damp_y, tend, u_m, &
-                         v_m, w_m, z0 )
+                         v_m, w_m )
     ELSE
-       CALL diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, w, &
-                         z0 )
+       CALL diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, w )
     ENDIF
     CALL coriolis( 3 )