Index: palm/trunk/DOC/app/chapter_4.2.html
===================================================================
--- palm/trunk/DOC/app/chapter_4.2.html	(revision 54)
+++ palm/trunk/DOC/app/chapter_4.2.html	(revision 61)
@@ -6,6 +6,6 @@
 parameters</a></h3>
 <h3 style="margin-bottom: 0cm; line-height: 100%;"><a name="Laufparameter"></a>Runtime parameters:</h3>
-<br><br>
-<table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody> <tr>
+<br><br><table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody>
+<tr>
 <td style="vertical-align: top;"><font size="4"><b>Parameter
 name</b></font></td> <td style="vertical-align: top;"><font size="4"><b>Type</b></font></td>
@@ -41,6 +41,6 @@
 <td style="vertical-align: top;"><span style="font-style: italic;">value of <a href="#averaging_interval">averaging_<br>
 interval</a><br>
-</span> </td> <td style="vertical-align: top;">
-<p>Averaging interval for output of vertical profiles&nbsp;to
+</span> </td> <td style="vertical-align: top;"><p>Averaging
+interval for output of vertical profiles&nbsp;to
 local
 file <font color="#000000"><font color="#000000"><a href="chapter_3.4.html#DATA_1D_PR_NETCDF">DATA_1D_PR_NETCDF</a>
@@ -80,6 +80,5 @@
 = <span style="font-style: italic;">.T.</span>
 should be used.&nbsp;<span style="font-weight: bold;"></span></td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="fcl_factor"></a><b>cfl_factor</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="fcl_factor"></a><b>cfl_factor</b></p>
 </td> <td style="vertical-align: top;">R<br> </td>
 <td style="vertical-align: top;"> <p><i>0.1,
@@ -108,6 +107,5 @@
 scheme is <span style="font-weight: bold;">cfl_factor</span>
 = <span style="font-style: italic;">0.8</span> .</font></span></td>
-</tr>
-<tr> <td style="vertical-align: top;"> <p><a name="create_disturbances"></a><b>create_disturbances</b></p>
+</tr><tr> <td style="vertical-align: top;"> <p><a name="create_disturbances"></a><b>create_disturbances</b></p>
 </td> <td style="vertical-align: top;">L<br> </td>
 <td style="vertical-align: top;"><span style="font-style: italic;">.T.</span><br> </td>
@@ -354,6 +352,5 @@
 computational cost of w-cycles is much higher than that of v-cycles,
 however, w-cycles give a much better convergence. </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="data_output"></a><b>data_output</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="data_output"></a><b>data_output</b></p>
 </td> <td style="vertical-align: top;">C * 10 (100)<br>
 </td> <td style="vertical-align: top;"><span style="font-style: italic;">100 * ' '</span><br>
@@ -776,6 +773,6 @@
 <td style="vertical-align: top;">Energy production by
 transport of resolved-scale TKE</td> </tr> </tbody>
-</table> <br>
-Beyond that, initial profiles (t=0) of some variables can be also be
+</table> <br>Beyond that, initial profiles (t=0) of some
+variables can be also be
 output (this output is only done once
 with the first plot output and not repeated with the profile output at
@@ -835,6 +832,5 @@
 only an
 approximate value of the real magnitude of the perturbation.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="disturbance_energy_limit"></a><b>disturbance_energy</b>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="disturbance_energy_limit"></a><b>disturbance_energy</b>
 <br> <b>_limit</b></p> </td> <td style="vertical-align: top;">R</td> <td style="vertical-align: top;"><i>0.01</i></td>
 <td style="vertical-align: top;"> <p lang="en-GB">Upper
@@ -852,6 +848,5 @@
 must be determined by trial and error (it depends e.g. on the total
 number of grid points).</span> </font> </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="disturbance_level_b"></a><b>disturbance_level_b</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="disturbance_level_b"></a><b>disturbance_level_b</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>zu(3)</i></td>
@@ -954,6 +949,5 @@
 <p>The default assignment is <span style="font-weight: bold;">do3d_precision</span>
 = <span style="font-style: italic;">'u2'</span>, <span style="font-style: italic;">'v2'</span>, <span style="font-style: italic;">'w2'</span>, <span style="font-style: italic;">'p5'</span>, <span style="font-style: italic;">'pt2'</span>.</p> </td>
-</tr>
-<tr> <td style="vertical-align: top;"> <p><a name="dt_laufparameter"></a><b>dt</b></p>
+</tr><tr> <td style="vertical-align: top;"> <p><a name="dt_laufparameter"></a><b>dt</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>variable</i></td>
@@ -1067,6 +1061,5 @@
 these theoretical values</font></span><a href="chapter_4.2.html#dt_dopr_zeitpunkte"><span lang="en-GB"></span></a><span lang="en-GB"><font face="Thorndale">.<br><br></font></span>The
 length of the averaging interval is controlled via parameter <a href="chapter_4.2.html#averaging_interval">averaging_interval</a>.</td>
-</tr>
-<tr> <td style="vertical-align: top;"> <p><a name="dt_disturb"></a><b>dt_disturb</b></p>
+</tr><tr> <td style="vertical-align: top;"> <p><a name="dt_disturb"></a><b>dt_disturb</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>9999999.9</i></td>
@@ -1410,5 +1403,9 @@
 the time t = 0 or at the
 respective starting times of restart runs).</font></span> </p>
-</td> </tr> <tr> <td style="vertical-align: top;"> <p><a name="dt_restart"></a><b>dt_restart</b></p>
+</td> </tr> <tr><td style="vertical-align: top;"><a name="dt_max"></a><span style="font-weight: bold;">dt_max</span></td><td style="vertical-align: top;">R</td><td style="vertical-align: top;"><span style="font-style: italic;">20.0</span></td><td>Maximum
+allowed value of the timestep (in s).<br><br>By default,
+the maximum timestep is restricted to be 20 s. This might be o.k. for
+simulations of any kind of atmospheric turbulence but may have to be
+changed for other situations.</td></tr><tr> <td style="vertical-align: top;"> <p><a name="dt_restart"></a><b>dt_restart</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>9999999.9</i></td>
@@ -1440,6 +1437,5 @@
 information is output after each time step can be achieved via <b>dt_run_control</b>
 = <i>0.0</i>.</font></span> </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="end_time"></a><b>end_time</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="end_time"></a><b>end_time</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>0.0</i></td>
@@ -1471,6 +1467,6 @@
 perturbation pressure (see <a href="#psolver">psolver</a>).
 The type of the cycles can be set with <a href="#cycle_mg">cycle_mg</a>.<br>
-</p> <br>
-By default (<b>mg_cyles</b> = <i>- 1</i>), the
+</p> <br>By default (<b>mg_cyles</b> = <i>-
+1</i>), the
 number of cycles
 depends on the requested accuracy of the scheme (see <a href="#residual_limit">residual_limit</a>)
@@ -1516,6 +1512,5 @@
 using <a href="#netcdf_64bit_3d">netcdf_64bit_3d</a>.<br><br><span style="font-weight: bold;">Warning:</span><br>Some
 (PD or commercial) software may not support the 64 bit offset format.<br>
-</td> </tr>
-<tr><td style="vertical-align: top;"><a name="netcdf_64bit_3d"></a><span style="font-weight: bold;">netcdf_64bit_3d</span></td><td style="vertical-align: top;">L</td><td style="vertical-align: top;">.T.</td><td style="vertical-align: top;">NetCDF files containing 3d
+</td> </tr><tr><td style="vertical-align: top;"><a name="netcdf_64bit_3d"></a><span style="font-weight: bold;">netcdf_64bit_3d</span></td><td style="vertical-align: top;">L</td><td style="vertical-align: top;">.T.</td><td style="vertical-align: top;">NetCDF files containing 3d
 volume data will have 64 bit offset format.<br><br>This
 switch&nbsp;only comes into effect if <a href="#netcdf_64bit">netcdf_64bit</a>
@@ -1580,6 +1575,5 @@
 for <span style="font-weight: bold;">dvrp</span>-software,
 see <a href="#mode_dvrp">mode_dvrp</a>).</td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="omega_sor"></a><b>omega_sor</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="omega_sor"></a><b>omega_sor</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>1.8</i></td>
@@ -1654,6 +1648,6 @@
 This solver is specially optimized for 1d domain decompositions.
 Vectorization is optimized for domain decompositions along x only.</td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><i>poisfft_</i> <br> <i>hybrid</i></p>
+</tr> <tr> <td style="vertical-align: top;"><p><i>poisfft_</i>
+<br> <i>hybrid</i></p>
 </td> <td style="vertical-align: top;">Direct
 method using FFT
@@ -1679,6 +1673,5 @@
 smaller this limit is, the more cycles have to be carried out in this
 case and the number of cycles may vary from timestep to timestep.</p>
-<br>
-If <a href="#mg_cycles">mg_cycles</a>
+<br>If <a href="#mg_cycles">mg_cycles</a>
 is set to its optimal value, the computing time of the
 multi-grid scheme amounts approximately to that of the direct solver <span style="font-style: italic;">poisfft</span>, as long as
@@ -1718,6 +1711,6 @@
 more computing time. It should only be used for test runs, e.g. if
 errors in the other pressure solver methods are assumed.</td> </tr>
-</tbody> </table> <br>
-In order to speed-up performance, the Poisson equation is by default
+</tbody> </table> <br>In order to speed-up
+performance, the Poisson equation is by default
 only solved at the last substep of a multistep Runge-Kutta scheme (see <a href="#call_psolver_at_all_substeps">call_psolver
 at_all_substeps</a> and <a href="chapter_4.1.html#timestep_scheme">timestep_scheme</a>).&nbsp;
@@ -1752,6 +1745,5 @@
 <td style="vertical-align: top;"> <p><a name="rayleigh_damping_height"></a><b>rayleigh_damping</b>
 <br> <b>_height</b></p> </td> <td style="vertical-align: top;">R</td> <td style="vertical-align: top;"> <p><i>2/3 *</i>
-<br><span style="font-style: italic;">
-zu</span><i style="font-style: italic;">(nz)</i></p>
+<br><span style="font-style: italic;">zu</span><i style="font-style: italic;">(nz)</i></p>
 </td> <td style="vertical-align: top;"> <p>Height
 where the Rayleigh damping starts (in m).&nbsp; </p> <p>With
@@ -1778,6 +1770,5 @@
 been applied (thus the default value causes a reduction of the
 divergence by approx. 6 orders of magnitude).&nbsp; </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="restart_time"></a><b>restart_time</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="restart_time"></a><b>restart_time</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>9999999.9</i></td>
@@ -1829,6 +1820,5 @@
 successively written to file. The output order follows the order given
 by <b>section_xy</b>.&nbsp;</font></span></td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="section_xz"></a><b>section_xz</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="section_xz"></a><b>section_xz</b></p>
 </td> <td style="vertical-align: top;">I(100)<br>
 </td> <td style="vertical-align: top;"><span style="font-style: italic;">no section</span></td>
@@ -1858,6 +1848,5 @@
 then the respective data are successively written to file. The output
 order follows the order given by <b>section_xz</b>.</font></span></td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="section_yz"></a><b>section_yz</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="section_yz"></a><b>section_yz</b></p>
 </td> <td style="vertical-align: top;">I(100)<br>
 </td> <td style="vertical-align: top;"><span style="font-style: italic;">no section</span></td>
@@ -2089,6 +2078,5 @@
 (the respective <span style="font-weight: bold;">iso2d</span>-parameter
 is <a href="http://www.muk.uni-hannover.de/institut/software/iso2d_beschreibung.html#YRIGHT">yright</a>).</p>
-</td> </tr> </tbody>
-</table><br>
+</td> </tr> </tbody></table><br>
 <br><h3 style="line-height: 100%;"><a name="Paketparameter"></a>Package
 parameters: </h3>
@@ -2096,6 +2084,7 @@
 option -p): <span style="font-weight: bold;"><a name="particles_package"></a>particles</span>&nbsp;&nbsp;&nbsp;&nbsp;
 NAMELIST group name: <span style="font-weight: bold;">particles_par<br>
-</span><table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody>
-<tr> <td style="vertical-align: top;"><font size="4"><b>Parameter name</b></font></td>
+</span><table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody><tr>
+<td style="vertical-align: top;"><font size="4"><b>Parameter
+name</b></font></td>
 <td style="vertical-align: top;"><font size="4"><b>Type</b></font></td>
 <td style="vertical-align: top;"> <p><b><font size="4">Default</font></b> <br> <b><font size="4">value</font></b></p> </td>
@@ -2206,6 +2195,5 @@
 work
 duly in case of a constant vertical grid spacing!</b></p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="bc_par_b"></a><b>bc_par_b</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="bc_par_b"></a><b>bc_par_b</b></p>
 </td> <td style="vertical-align: top;">C*15</td>
 <td style="vertical-align: top;"><i>&acute;reflect&acute;</i></td>
@@ -2215,6 +2203,5 @@
 Alternatively, a particle absorption can set by <b>bc_par_b</b>
 = <i>&acute;absorb&acute;</i>.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="bc_par_lr"></a><b>bc_par_lr</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="bc_par_lr"></a><b>bc_par_lr</b></p>
 </td> <td style="vertical-align: top;">C*15</td>
 <td style="vertical-align: top;"><i>&acute;cyclic&acute;</i></td>
@@ -2229,6 +2216,5 @@
 conditions should correspond to the
 lateral boundary condition used for the flow (see <a href="chapter_4.1.html#bc_lr">bc_lr</a>).</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="bc_par_ns"></a><b>bc_par_ns</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="bc_par_ns"></a><b>bc_par_ns</b></p>
 </td> <td style="vertical-align: top;">C*15</td>
 <td style="vertical-align: top;"><i>&acute;cyclic&acute;</i></td>
@@ -2251,6 +2237,5 @@
 Alternatively, a reflection condition can be set by <b>bc_par_t</b>
 = <i>&acute;reflect&acute;</i>.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="density_ratio"></a><b>density_ratio</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="density_ratio"></a><b>density_ratio</b></p>
 </td> <td style="vertical-align: top;">R (10)</td>
 <td style="vertical-align: top;"> <p><i>0.0, 9</i>
@@ -2379,6 +2364,5 @@
 </font></span><a href="chapter_4.2.html#pdz"><span lang="en-GB"><font face="Thorndale, serif">pdz</font></span></a><span lang="en-GB"></span><span lang="en-GB"></span>)
 times the <span style="font-weight: bold;">initial_weighting_factor</span>.</td>
-</tr>
-<tr> <td style="vertical-align: top;"> <p><a name="maximum_number_of_particles"></a><b>maximum_number_of_</b>
+</tr><tr> <td style="vertical-align: top;"> <p><a name="maximum_number_of_particles"></a><b>maximum_number_of_</b>
 <br> <b>particles</b></p> </td> <td style="vertical-align: top;">I</td> <td style="vertical-align: top;"><i>1000</i></td>
 <td style="vertical-align: top;"> <p>Maximum number
@@ -2393,6 +2377,5 @@
 the maximum number on each PE. This number must be larger than the
 maximum number of particles initially released in a subdomain.</td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="maximum_number_of_tailpoints"></a><b>maximum_number_of_</b>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="maximum_number_of_tailpoints"></a><b>maximum_number_of_</b>
 <br> <b>tailpoints</b></p> </td> <td style="vertical-align: top;">I</td> <td style="vertical-align: top;"><i>100</i></td>
 <td style="vertical-align: top;"> <p>Maximum number
@@ -2465,6 +2448,5 @@
 the parameter).<br> <br>
 The maximum allowed number of particle groups is limited to <span style="font-style: italic;">10</span>.<br> </td>
-</tr>
-<tr><td align="left" valign="top"><a name="particles_per_point"></a><span style="font-weight: bold;">particles_per_point</span></td><td align="left" valign="top">I</td><td align="left" valign="top">1</td><td align="left" valign="top">Number of particles to be
+</tr><tr><td align="left" valign="top"><a name="particles_per_point"></a><span style="font-weight: bold;">particles_per_point</span></td><td align="left" valign="top">I</td><td align="left" valign="top">1</td><td align="left" valign="top">Number of particles to be
 started per point.<br><br>By default, one particle is
 started at all points of the particle source,&nbsp;defined by <span style="font-family: Thorndale,serif;">the </span><span lang="en-GB"><font face="Thorndale, serif">package
@@ -2547,6 +2529,6 @@
 <td style="vertical-align: top;"><i>0.0, 9</i>*<br>
 <i>9999999.9</i></td> <td style="vertical-align: top;">Particle radius (in m).<br>
-<br>
-The viscous friction (in case of a velocity difference between
+<br>The viscous friction (in case of a velocity difference
+between
 particles and surrounding fluid) depends on the particle radius which
 must be assigned as soon as <a href="chapter_4.2.html#density_ratio">density_ratio</a>
@@ -2559,6 +2541,5 @@
 then the last assigned value is used for all remaining groups. This
 means that by default the particle radius for all groups will be <span style="font-style: italic;">0.0</span>.<br> </td>
-</tr>
-<tr> <td style="vertical-align: top;"> <p><a name="random_start_position"></a><b>random_start_position</b></p>
+</tr><tr> <td style="vertical-align: top;"> <p><a name="random_start_position"></a><b>random_start_position</b></p>
 </td> <td style="vertical-align: top;">L<br> </td>
 <td style="vertical-align: top;"><i>.F.</i> </td>
@@ -2611,6 +2592,5 @@
 <td style="vertical-align: top;"><span style="font-style: italic;">.F.</span><br> </td>
 <td style="vertical-align: top;">Give particles a tail.<br>
-<br>
-A particle tail is defined by the path a particle has moved
+<br>A particle tail is defined by the path a particle has moved
 along starting from some point of time in the past. It consists of a
 set of descrete points in space which may e.g. be connected by a line
@@ -2620,6 +2600,5 @@
 The length of the tail is controlled by parameters&nbsp;<a href="#maximum_number_of_tailpoints">maximum_number_of_tailpoints</a>,&nbsp;<a href="#maximum_tailpoint_age">maximum_tailpoint_age</a>,
 and <a href="#minimum_tailpoint_distance">minimum_tailpoint_distance</a>.<br>
-</td> </tr>
-<tr><td align="left" valign="top"><a name="use_sgs_for_particles"></a><span style="font-weight: bold;">use_sgs_for_particles</span></td><td align="left" valign="top">L</td><td align="left" valign="top"><span style="font-style: italic;">.F.</span></td><td align="left" valign="top">Use subgrid-scale
+</td> </tr><tr><td align="left" valign="top"><a name="use_sgs_for_particles"></a><span style="font-weight: bold;">use_sgs_for_particles</span></td><td align="left" valign="top">L</td><td align="left" valign="top"><span style="font-style: italic;">.F.</span></td><td align="left" valign="top">Use subgrid-scale
 velocities for particle advection.<br><br>These
 velocities are calculated from the resolved and subgrid-scale TKE using
@@ -2647,6 +2626,5 @@
 = <i>.F., </i>the
 particles will only be transported horizontally.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="write_particle_statistics"></a><b>write_particle_</b>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="write_particle_statistics"></a><b>write_particle_</b>
 <br> <b>statistics</b></p> </td> <td style="vertical-align: top;">L<br> </td> <td style="vertical-align: top;"><i>.F.</i> </td>
 <td style="vertical-align: top;"> <p>Switch on/off
@@ -2661,6 +2639,5 @@
 may become very large
 and performance of PALM may decrease.</p> </td> </tr>
-</tbody>
-</table><span style="font-weight: bold;"><br>
+</tbody></table><span style="font-weight: bold;"><br>
 <br></span><span style="font-weight: bold;">Package
 (<span style="font-weight: bold;">mrun</span> option
@@ -2668,12 +2645,10 @@
 &nbsp;&nbsp;&nbsp;
 NAMELIST group name: <span style="font-weight: bold;">dvrp_graphics_par<br>
-<br></span></span>
-<table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody> <tr>
+<br></span></span><table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody> <tr>
 <td style="vertical-align: top;"><font size="4"><b>Parameter
 name</b></font></td> <td style="vertical-align: top;"><font size="4"><b>Type</b></font></td>
 <td style="vertical-align: top;"> <p><b><font size="4">Default</font></b> <br> <b><font size="4">value</font></b></p> </td>
 <td style="vertical-align: top;"><font size="4"><b>Explanation</b></font></td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="dt_dvrp"></a><b>dt_dvrp</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="dt_dvrp"></a><b>dt_dvrp</b></p>
 </td> <td style="vertical-align: top;">R</td>
 <td style="vertical-align: top;"><i>9999999.9</i></td>
@@ -2699,6 +2674,5 @@
 output after each time step (if this is requested it should be <b>dt_dvrp</b>
 = <i>0</i>).</font></span> </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="dvrp_directory"></a><b>dvrp_directory</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="dvrp_directory"></a><b>dvrp_directory</b></p>
 </td> <td style="vertical-align: top;">C*80</td>
 <td style="vertical-align: top;"><i>'default'</i></td>
@@ -2711,6 +2685,5 @@
 and the base file name (given as the argument of <span style="font-weight: bold;">mrun</span> option -d) as <span style="font-style: italic;">'&lt;user
 name&gt;/&lt;base file name&gt;'</span>.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="dvrp_file"></a><b>dvrp_file</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="dvrp_file"></a><b>dvrp_file</b></p>
 </td> <td style="vertical-align: top;">C*80</td>
 <td style="vertical-align: top;"><i>'default'</i></td>
@@ -2729,6 +2702,5 @@
 </td> <td style="vertical-align: top;">C*80</td>
 <td style="vertical-align: top;"> <p><i>'origin.rvs.</i>
-<br>
-u<i>ni- hanover.de'</i></p> </td> <td style="vertical-align: top;"> <p>Name of the computer
+<br>u<i>ni- hanover.de'</i></p> </td> <td style="vertical-align: top;"> <p>Name of the computer
 to which data created by the <span style="font-weight: bold;">dvrp</span>
 software shall be
@@ -2910,6 +2882,5 @@
 used to
 stretch the displayed domain along the y-direction. See also <a href="#superelevation">superelevation</a>.</p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="threshold"></a><b>threshold</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="threshold"></a><b>threshold</b></p>
 </td> <td style="vertical-align: top;">R(10)<br>
 </td> <td style="vertical-align: top; font-style: italic;">0.0<br>
@@ -2927,17 +2898,14 @@
 each isosurface can be assigned. The order of the threshold values
 refers to the order of the isosurfaces given by <b>mode_dvrp</b>.</p>
-</td> </tr> </tbody>
-</table><span style="font-weight: bold;"><span style="font-weight: bold;"><br>
+</td> </tr> </tbody></table><span style="font-weight: bold;"><span style="font-weight: bold;"><br>
 </span></span><span style="font-weight: bold;"><span style="font-weight: bold;">Package (<span style="font-weight: bold;">mrun</span>
 option -p): <span style="font-weight: bold;"><a name="spectra"></a>spectra</span>&nbsp;&nbsp;&nbsp;&nbsp;
 NAMELIST group name: <span style="font-weight: bold;">spectra_par<br>
-<br></span></span></span>
-<table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody> <tr>
+<br></span></span></span><table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2"> <tbody> <tr>
 <td style="vertical-align: top;"><font size="4"><b>Parameter
 name</b></font></td> <td style="vertical-align: top;"><font size="4"><b>Type</b></font></td>
 <td style="vertical-align: top;"> <p><b><font size="4">Default</font></b> <br> <b><font size="4">value</font></b></p> </td>
 <td style="vertical-align: top;"><font size="4"><b>Explanation</b></font></td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="averaging_interval_sp"></a><b>averaging_interval_sp</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="averaging_interval_sp"></a><b>averaging_interval_sp</b></p>
 </td> <td style="vertical-align: top;">R<br> </td>
 <td style="vertical-align: top;"><span style="font-style: italic;">value of <a href="chapter_4.2.html#averaging_interval">averaging_<br>
@@ -3052,6 +3020,5 @@
 after each time step (if this is requested it should be <b>dt_dosp</b>
 = <i>0</i>).</font></span> </p> </td>
-</tr> <tr> <td style="vertical-align: top;">
-<p><a name="plot_spectra_level"></a><b>plot_spectra_level</b></p>
+</tr> <tr> <td style="vertical-align: top;"><p><a name="plot_spectra_level"></a><b>plot_spectra_level</b></p>
 </td> <td style="vertical-align: top;">I(10)</td>
 <td style="vertical-align: top;"><i>no level</i></td>
@@ -3087,9 +3054,6 @@
 along the respective directions (see <a href="chapter_4.1.html#bc_lr">bc_lr</a>
 and <a href="chapter_4.1.html#bc_ns">bc_ns</a>).</p>
-</td> </tr> </tbody>
-</table><span style="font-weight: bold;"><span style="font-weight: bold;"><span style="font-weight: bold;"><br>
-</span></span></span><h3 style="line-height: 100%;"><br>
-<a href="chapter_4.1.html"><img src="left.gif" name="Grafik1" align="bottom" border="2" height="32" width="32"></a><a href="index.html"><img src="up.gif" name="Grafik2" align="bottom" border="2" height="32" width="32"></a><a href="chapter_4.3.html"><img src="right.gif" name="Grafik3" align="bottom" border="2" height="32" width="32"></a></h3><span style="font-style: italic;">Last change:</span>
-22/08/06 (SR)<span style="font-weight: bold;"><span style="font-weight: bold;"><br>
-</span></span><br>
-</body></html>
+</td> </tr> </tbody></table><span style="font-weight: bold;"><span style="font-weight: bold;"><span style="font-weight: bold;"><br>
+</span></span></span><h3 style="line-height: 100%;"><br><a href="chapter_4.1.html"><img src="left.gif" name="Grafik1" align="bottom" border="2" height="32" width="32"></a><a href="index.html"><img src="up.gif" name="Grafik2" align="bottom" border="2" height="32" width="32"></a><a href="chapter_4.3.html"><img src="right.gif" name="Grafik3" align="bottom" border="2" height="32" width="32"></a></h3><span style="font-style: italic;">Last change:</span>
+$Id$ <span style="font-weight: bold;"><span style="font-weight: bold;"><br>
+</span></span><br></body></html>